﻿Imports C1.C1Schedule
Imports C1.Win.C1Schedule

Public Module Module1
    Public applist(20) As Appointment
    Public i As Integer = 0
    Public dayinterval(20) As Integer
    Public count As Integer = 0
End Module

Public Class Form1
    Dim app1 As Appointment, app2 As Appointment

    Private Sub Form1_Load(sender As Object, e As EventArgs) Handles MyBase.Load
        app1 = New Appointment()
        app1.Subject = "Meeting - 1"
        app1.Location = "Meeting Room1, Grapecity"
        app1.Start = DateTime.Now
        app1.End = DateTime.Now.AddMinutes(30)

        C1Schedule1.DataStorage.AppointmentStorage.Appointments.Add(app1)

        app2 = New Appointment()
        app2.Subject = "Meeting - 2"
        app2.Location = "Meeting Room4, Grapecity"
        app2.Start = DateTime.Now.AddDays(2)
        app2.End = DateTime.Now.AddDays(2).AddMinutes(30)

        C1Schedule1.DataStorage.AppointmentStorage.Appointments.Add(app2)

        AddHandler C1Schedule1.KeyDown, AddressOf C1Schedule1_KeyDown
        AddHandler C1Schedule2.KeyDown, AddressOf C1Schedule2_KeyDown

    End Sub

    Private Sub C1Schedule1_KeyDown(sender As Object, e As KeyEventArgs)

        If (e.Modifiers = Keys.Control And e.KeyCode = Keys.C) Then

            If (C1Schedule1.SelectedAppointments.Count > 0) Then
                count = C1Schedule1.SelectedAppointments.Count

                For i As Integer = 0 To count - 2
                    dayinterval(i) = DateDiff(DateInterval.Day, C1Schedule1.SelectedAppointments(i).Start.Date, C1Schedule1.SelectedAppointments(i + 1).Start.Date)
                Next


                For k As Integer = 0 To count - 1
                    applist(k) = C1Schedule1.SelectedAppointments(k).Copy()
                Next
          
            End If

        ElseIf (e.Modifiers = Keys.Control And e.KeyCode = Keys.V) Then

            Dim selecteddate As Date = C1Schedule1.SelectedInterval.Start

            For i As Integer = 0 To count - 1
                Dim appnew1 As Appointment = New Appointment()

                appnew1.Body = appList(i).Body
                appnew1.Subject = appList(i).Subject
                appnew1.Location = appList(i).Location
                appnew1.Start = New DateTime(selecteddate.Year, selecteddate.Month, selecteddate.Day, appList(i).Start.Hour, appList(i).Start.Minute, appList(i).Start.Second)
                appnew1.Duration = applist(i).Duration
                appnew1.BusyStatus = applist(i).BusyStatus
                appnew1.Label = applist(i).Label
                appnew1.AllDayEvent = applist(i).AllDayEvent
                C1Schedule1.DataStorage.AppointmentStorage.Appointments.Add(appnew1)

                selecteddate = selecteddate.AddDays(dayinterval(i))

            Next

        End If

    End Sub

    Private Sub C1Schedule2_KeyDown(sender As Object, e As KeyEventArgs)
        If (e.Modifiers = Keys.Control And e.KeyCode = Keys.C) Then

            If (C1Schedule2.SelectedAppointments.Count > 0) Then
                count = C1Schedule2.SelectedAppointments.Count

                For i As Integer = 0 To count - 2
                    dayinterval(i) = DateDiff(DateInterval.Day, C1Schedule2.SelectedAppointments(i).Start.Date, C1Schedule2.SelectedAppointments(i + 1).Start.Date)
                Next

                For k As Integer = 0 To count - 1
                    applist(k) = C1Schedule2.SelectedAppointments(k).Copy()
                Next

            End If

        ElseIf (e.Modifiers = Keys.Control And e.KeyCode = Keys.V) Then

            Dim selecteddate As Date = C1Schedule2.SelectedInterval.Start

            For i As Integer = 0 To count - 1
                Dim appnew1 As Appointment = New Appointment()

                appnew1.Body = applist(i).Body
                appnew1.Subject = applist(i).Subject
                appnew1.Location = applist(i).Location
                appnew1.Start = New DateTime(selecteddate.Year, selecteddate.Month, selecteddate.Day, applist(i).Start.Hour, applist(i).Start.Minute, applist(i).Start.Second)
                appnew1.Duration = applist(i).Duration
                appnew1.BusyStatus = applist(i).BusyStatus
                appnew1.Label = applist(i).Label
                appnew1.AllDayEvent = applist(i).AllDayEvent

                C1Schedule2.DataStorage.AppointmentStorage.Appointments.Add(appnew1)

                selecteddate = selecteddate.AddDays(dayinterval(i))

            Next

        End If
    End Sub

    Private Sub btn_OpenForm_Click(sender As Object, e As EventArgs) Handles btn_OpenForm.Click
        Dim frm As Form1 = New Form1()
        frm.Show()
    End Sub
    
End Class
